/*************************************************
This sloppy file parses a large text file with The Complete
Works of William Shakespeare in it.  I have manually
removed all extra whitespace as well as the sonetts.

The original file can be found at:
http://www.gutenberg.org/etext/100

  -Michael Hill
  
  www.wetdogstudios.com
*************************************************/

void setup() {
 ArrayList dateLocation = new ArrayList(); //Holds beginning of play location
 ArrayList endLocation = new ArrayList(); //Holds endo of play location
 String[] container;
 
 String fullText[] = loadStrings("data/shakespeare_full.txt"); //Full text of all plays
 
 for (int i=0; i < fullText.length; i++){
   container= match(fullText[i], "^[0-9][0-9][0-9][0-9]"); //Find date in line - All plays begin with a date 
   if (container != null){
     dateLocation.add(Integer.toString(i));  //ArrayLists dont like ints >.<
   }
   else{
     container= match(fullText[i], "THE END");
     if (container != null){
       endLocation.add(Integer.toString(i));  //ArrayLists dont like ints >.<
     }
   }
 }

 for (int i=0; i < dateLocation.size(); i++) {
   int beginLine = Integer.parseInt((String) dateLocation.get(i));  //Sillyness regarding having to convert
   println("Play " + i + " begins on line " + beginLine);                                              //ArrayLists stuff to String
   
   int endLine = Integer.parseInt((String) endLocation.get(i));  //Sillyness regarding having to convert
   println("Play " + i + " ends on line " + endLine);                                              //ArrayLists stuff to String
   
   int playLength = endLine-beginLine;
   String[] play = new String[playLength]; //Create a string array that is the length of the play
   
   for (int j = 0; j < playLength; j++){
     play[j] = fullText[j + beginLine];  //Populate array with play text
   }
   saveStrings(play[1] + ".txt", play);  //Save file with play (Name of play is always the 2nd item in the array
   println("The play '" + play[1] + "' was just saved to a file");
    
 }

}
